package ladasha.io;

import java.util.*;
import java.io.*;

public class ProfileHandler {

	private static File profile;
	private static HashMap<Double,Double> map = new HashMap<Double,Double>();
	private static ProfileHandler instance = ProfileHandler.getInstance();
  private static Scanner sc;
	
	private ProfileHandler() {}
	
	public static ProfileHandler getInstance() {
		if (instance == null) return new ProfileHandler();
		else return instance;
	}

	public static void setProfile(File newProfile) {
		if (newProfile == null) return;
		profile = newProfile;
	}

	public static void reader() throws IOException {
		int count = 0;
		StringBuilder builder = new StringBuilder(count);
		try {
		  sc = new Scanner(new FileInputStream(profile));
		} catch (FileNotFoundException f) {}
		sc.useDelimiter(",");
		try {
			while (sc.hasNext()) {
				count++;
				builder.append(sc.nextDouble() + "\n");
			}
		} catch (Exception exception) {
		} finally { sc.close(); }
		System.out.print(builder);
		System.out.print(count);
	}

	public static boolean isGaussian() {
	        try {
		  sc = new Scanner(new FileInputStream(profile));
		} catch (FileNotFoundException f) {}
		return sc.next().startsWith("[");    
	}

	
	public static boolean isDiscrete() { 
		try {
		  sc = new Scanner(new FileInputStream(profile));
		} catch (FileNotFoundException f) {}
		return !sc.next().startsWith("[");
	}
	
	public static HashMap<Double,Double> getDiscrete() { 
		if (!isDiscrete()) return null;
		// variables
		int count = 0;
		double key = 0;
		double value = 0;
		try {
		  sc = new Scanner(new FileInputStream(profile));
		} catch (FileNotFoundException f) {}
		sc.useDelimiter(",");
		// if count is divisible by 2
		while (sc.hasNext()) {
			double token = sc.nextDouble();
			if (count % 2 == 1) { // value, not a key
				value += token;
				map.put(key, token);
			} else
				key = token;
			count++;
		}
		if (value != 1.0) return null;
		else return map;
	}		
	
	public static Double[] getGaussian() { 
		if (!isGaussian()) return null;
		try {
		  sc = new Scanner(new FileInputStream(profile));
		} catch (FileNotFoundException f) {}
    sc.useDelimiter(",");
		String mu = sc.next();
    String sigma = sc.next();
    if (mu == null || sigma == null) return null;
		Double[] meanAndVariance = new Double[2];
		meanAndVariance[0] = Double.parseDouble(mu.substring(1,mu.length()));
		meanAndVariance[1] = Double.parseDouble(sigma.substring(0,sigma.length()-1));
		return meanAndVariance;
	}
}

class ProfileHandlerTester {

	public static void main (String[] args) {
		ProfileHandler p = ProfileHandler.getInstance();
		ProfileHandler.setProfile(new File("~/humanizer-current/classes/StdGaus1.mhp"));
		ProfileHandler.getGaussian();
	}
}

