package ladasha.statistics;

import java.util.*;

public class DiscreteRNG {
  
  private static DiscreteRNG instance = null;
  /*
  private static ArrayList<Double> probability;
  private static ArrayList<Double> distribution;
  */
  private static HashMap<Double,Double> probabilities;
  
  public static DiscreteRNG getInstance() {
    if (instance == null)
      instance = new DiscreteRNG();
    return instance;
  }
  
  private DiscreteRNG(){}
  
  /*
  public static void setProbability(ArrayList<Double> newProbability) {
    probability = newProbability;
  }
  
  public static void setDistribution(ArrayList<Double> newDistribution) {
    distribution = newDistribution;
  }
  */
  
  public static void setProbabilities(HashMap<Double,Double> newProbabilities) {
    probabilities = newProbabilities;
  }

  /*
  public double next() {
    Random r = new Random();
    double temp = r.nextDouble();
    for(Double d : probability) {
      if (temp <= d/1.0) {
        temp = distribution.get(probability.indexOf(d));
	      break;
      }
    }
    return temp;
  }
  */
  
  public static double next() {
    Random r = new Random();
    double temp = r.nextDouble();
    for(Double d : probabilities.keySet()) {
      if (temp <= d/1.0) {
        temp = probabilities.get(d);
	      break;
      }
    }
    return temp;
  }
}

/*
class DiscreteTester {

	static DiscreteRNG d;
	static ArrayList<Double> probability = new ArrayList<Double>();
	static ArrayList<Double> distribution = new ArrayList<Double>();
	static Scanner sc = new Scanner(System.in);

	static void prompt() {
		System.out.print("Next distribution >");
		double t = sc.nextDouble();
		distribution.add(t);
		System.out.print("Probability >");
		t = sc.nextDouble() + (probability.isEmpty() ? 0 : probability.get(probability.size()-1));
		probability.add(t);
		if (probability.get(probability.size()-1) == 1.0) {
			d = new DiscreteRNG(probability,distribution);
			return;
		} else if (probability.get(probability.size()-1) > 1.0) {
			System.out.println("Probabilities are greater than 100%... restarting");
			probability.clear();
			distribution.clear();
			prompt();
		} else prompt();
	}

	static void shoot() {
		for (int i = 0; i < 20; i++)
			System.out.println(d.next());
	}
			

	public static void main(String[] args) {
		prompt();
		shoot();
	}
}	
*/
